import Taro, { Component } from '@tarojs/taro'
import { View, Text, Picker } from '@tarojs/components'
import { AtList, AtListItem, } from 'taro-ui'

import './aliGoodsTypeInteraction.scss'
import loginExpired from '../../util/loginExpired'
import { getGlobalStorage } from '../../util/getSetStoage';

let maxDepth = 0
let initialDataArray = []
class AliGoodsTypeInteraction extends Component {

    config = {
        navigationBarTitleText: 'aliGoodsTypeInteraction'
    }
    constructor() {
        super(...arguments);

        this.state = {
            ///---行业分类 开始
            initailMultiArray: [[{ class_name: '选择商品分类', class_id: '' }], [], []], // 初始化底部数据
            multiIndex: [0, 0, 0, 0],// 默认联动列数为4个并且每一列都是第一行
            interactionMultiArray: [],// 联动


            ///---行业分类 结束
        }

    }
    //商品目录请求api GetShopCategoryList
    getProductCateList(url) {
        Taro.request({
            url: url,
            method: 'POST',
            dataType: 'json',
            header: {
                'content-type': 'application/x-www-form-urlencoded',
                'Cookie': 'PFWSSS=' + getGlobalStorage('session_id'),
                'X-Requested-With': 'XMLHttpRequest'
            }
        })
            .then(res => {
                if (res.data.err_code === 0) {
                    console.log('商品分类目录', res)

                    const recursionInteractionData = this.recursionInteraction(res.data.data)
                    maxDepth = 0
                    initialDataArray = []

                    this.recursionInitialized(res.data.data)  //
                    const depthInArray = this.recursionDepth(res.data.data)
                    console.log('depthInArray', depthInArray)
                    console.log('initialDataArray', initialDataArray)
                    for (let i = initialDataArray.length; i < depthInArray.length; i++) {
                        initialDataArray.unshift([{ name: '--', id: '' }])
                    }

                    this.setState({
                        interactionMultiArray: recursionInteractionData,
                        multiIndex: depthInArray,
                        initailMultiArray: initialDataArray.reverse()
                    }, () => {
                        console.log('interactionMultiArray',this.state.interactionMultiArray)
                        // 把全局变变量赋值给state之后，初始化商品分类为空， 不然第二次进去的时候会自动添加进去
                        //  console.log('联动数据', this.state.interactionMultiArray)
                        //  console.log('初始化数据', this.state.initailMultiArray)


                    }) // 用递归来整理无限层次的数据
                    //     console.log('联动数据', this.recursionInteraction(res.data.data))
                    //    console.log('初始数据', this.recursionInitialized(res.data.data).reverse())
                } else if (res.data.err_code === 88888) {
                    loginExpired(res)
                } else {
                    Taro.showToast({
                        title: res.data.err_msg,
                        icon: 'none'
                    })
                }
            }
            )
            .catch(error => {
                console.log('商品分类请求错误', error)
            })
    }

    //联动确认
    bindMultiPickerChange(e) {
        // 如果没有上商品 那就不执行
        if (getGlobalStorage('shopInfo').shop_id) {
            this.setState({
                multiIndex: e.detail.value.map(item => { if (item === null) { item = 0 } return item })
            }, () => {
                // console.log('picker发送选择改变，携带值为', this.state.multiIndex)
                this.returnResultToParent()

            })
        }
    }
    returnResultToParent() {
        let selected = this.state.interactionMultiArray
        for (let index of this.state.multiIndex) {
            if (selected[index].children[0].id) {
                selected = selected[index].children
            } else {
                this.props.onPassDataToChild(selected[index])
                break
            }
        }
    }
    // 递归整理无限层初始数据,将整理好的数据赋值给initialDataArray
    recursionInitialized(data) {
        const arrayTem = []
        if (data.length) {
            for (let item of data) {
                arrayTem.push({ name: item.class_name, id: item.class_id })
            }
        }
        if (data[0].children.length) {
            this.recursionInitialized(data[0].children)
        }
        initialDataArray.push(arrayTem)
        return arrayTem
    }



    // 递归整理无限层联动数据
    recursionInteraction(data) {
        let arrayTem = []
        for (let items of data) {
            arrayTem.push({ name: items.class_name, id: items.class_id })
            if (items.children) {
                arrayTem[arrayTem.length - 1].children = this.recursionInteraction(items.children)
            } else {
                arrayTem[arrayTem.length - 1].children = [{ name: '--', id: '' }]
            }
        }
        return arrayTem  // 返回联动数据
        //  return arrayTem
    }
    // 递归整理无限层初始数据
    // recursionInitialized(data) {
    //     const arrayTem = []
    //     const childrenHolderArray = []
    //     if (data.length) {
    //         for (let item of data) {
    //             arrayTem.push({ name: item.class_name, id: item.class_id })
    //             item.children ? childrenHolderArray.push(...item.children) : null
    //         }
    //         this.recursionInitialized(childrenHolderArray)
    //     }

    //     arrayTem.length ? initialDataArray.push(arrayTem) : null // 数组为空则不添加
    //     return initialDataArray
    // }

    // 递归整理无限层初始数据
    recursionDepth(data) {
        const arrayTem = []
        const childrenHolderArray = []
        if (data.length) {
            for (let item of data) {
                arrayTem.push({ name: item.class_name, id: item.class_id })
                item.children ? childrenHolderArray.push(...item.children) : null
            }
            this.recursionDepth(childrenHolderArray)
            maxDepth += 1
        }
        return new Array(maxDepth).fill(0)
    }

    // 触动联动筛选
    bindMultiPickerCol(e) {
        console.log('修改的列为', e.detail.column, '，值为', e.detail.value)
        console.log(this.state.initailMultiArray)
        const data = {
            multiArray: this.state.initailMultiArray,
            multiIndex: this.state.multiIndex
        }
        data.multiIndex[e.detail.column] = e.detail.value


        if (e.detail.column == 0) {
            for (let index in data.multiArray[0]) {
                const indexNumber = Number(index)
                if (indexNumber === data.multiIndex[0]) {
                    data.multiArray[1] = this.state.interactionMultiArray[indexNumber].children
                    data.multiArray[2] = this.state.interactionMultiArray[indexNumber].children[data.multiIndex[1]].children
                    data.multiArray[3] = this.state.interactionMultiArray[indexNumber].children[data.multiIndex[1]].children[data.multiIndex[2]].children
                }
            }
        } else if (e.detail.column == 1) {
            for (let index in data.multiArray[1]) {
                const indexNumber = Number(index)
                if (indexNumber === data.multiIndex[1]) {
                    data.multiArray[2] = this.state.interactionMultiArray[data.multiIndex[0]].children[indexNumber].children
                }
            }
        }
        else if (e.detail.column == 2) {
            for (let index in data.multiArray[2]) {
                const indexNumber = Number(index)
                if (indexNumber === data.multiIndex[2]) {
                    data.multiArray[3] = this.state.interactionMultiArray[data.multiIndex[0]].children[data.multiIndex[1]].children[indexNumber].children
                }
            }
        }

        this.setState({ multiIndex: data.multiIndex })
    }

    aliBindMultiPickerCol(e) {
        console.log('，值为', e.detail.value)

        this.setState({ multiIndex: e.detail.value })
    }

    aliCancelButton() {
        this.setState({
            AliIsShowPicker: false
        })
    }
    aliConfirmButton() {
        this.setState({
            AliIsShowPicker: false
        })
        this.returnResultToParent()
    }
    invokeAliPicker() {
        this.setState({
            AliIsShowPicker: true
        })
    }

    componentDidMount() {

        if (getGlobalStorage('shopInfo').shop_id) {
            this.getProductCateList(this.props.url)
        } else {

        }

    }
    // 当然父组件有新的props的 会从新渲染组件
    componentWillReceiveProps(nextProps) {

    }
    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        return (
            <View className='goods-interaction' >
                <View className='picker-wrapper' onClick={this.invokeAliPicker.bind(this)} >
                    <AtList  >
                        <AtListItem hasBorder={false} title='商品分类' className='title' extraText={this.props.selectedValue.name} arrow='right' />
                    </AtList>
                </View>
                {this.state.AliIsShowPicker ? <View>
                    <View className='curtain' onClick={this.aliCancelButton.bind(this)} > </View>

                    <View class='ali-picker-container'>
                        <View className='button'>
                            <View className='cancel-button' onClick={this.aliCancelButton.bind(this)}>取消</View>
                            <View className='confirm-button ali-blue-color' onClick={this.aliConfirmButton.bind(this)}>确定</View>
                        </View>
                        <picker-view value={this.state.multiIndex} onChange={this.aliBindMultiPickerCol.bind(this)}>
                            <picker-view-column>
                                {this.state.interactionMultiArray.map((item, index) => {
                                    return <View key={index}>{item.name}</View>
                                })}
                            </picker-view-column>
                            <picker-view-column>
                                {this.state.interactionMultiArray[this.state.multiIndex[0]].children.map((item, index) => {
                                    return <View key={index}>{item.name}</View>
                                })}
                            </picker-view-column>
                            <picker-view-column>
                                {this.state.interactionMultiArray[this.state.multiIndex[0]].children[this.state.multiIndex[1]].children.map((item, index) => {
                                    return <View key={index}>{item.name}</View>
                                })}
                            </picker-view-column>
                            <picker-view-column>
                                {this.state.interactionMultiArray[this.state.multiIndex[0]].children[this.state.multiIndex[1]].children[this.state.multiIndex[2]].children.map((item, index) => {
                                    return <View key={index}>{item.name}</View>
                                })}
                            </picker-view-column>
                        </picker-view>
                    </View ></View> : null}
            </View>


        )
    }
}

export default AliGoodsTypeInteraction


