import Taro, { Component } from '@tarojs/taro'
import { View, Image, Text } from '@tarojs/components'
import { AtTabs, AtTabsPane, AtSegmentedControl } from 'taro-ui'
import URL from '../../../serviceAPI.config'




import './goodCommentSection.scss'
// 需要的props
//productImagesUrl，current，subCurrent,onhandleClick,onClick


class GoodCommentSection extends Component {
    config = {
        navigationBarTitleText: '商品详情和评论'
    }

    passMainCurrentToParent(value){
        this.props.onMainOnClick(value) 
    }
    passSubCurrentToParent(value){
        this.props.onSubOnClick(value) 
    }
    componentDidMount() {

    }
    componentWillReceiveProps(nextProps) {

    }

    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        const mainTabList = [{ title: '宝贝详情' }, { title: '全部评价' }, { title: '猜你喜欢' }]
        const { productImagesUrl, mainCurrent, subCurrent, } = this.props
        const itemDescriptionPicsElementArray = productImagesUrl.map((item, index) => {
            return <View className='description-img' key={index}>
                <Image mode='widthFix' src={URL.Base + item.file_path} style='width: 100%; max-height:100%;' />

            </View>
        })
        return (
            <View className='good-info-section'>
                <View className='details-box'>
                    {/* 大类 */}
                    <AtTabs className='alltabs' animated={false} current={mainCurrent} tabList={mainTabList} onClick={this.passMainCurrentToParent.bind(this)}>
                        <AtTabsPane style='color:red' current={this.state.current} index={0} >
                            <View style='background-color: #FAFBFC;' >

                                <View className='description-title'>商品细节：</View>
                                <View className='description-img'>
                                    {itemDescriptionPicsElementArray}

                                </View>

                            </View>
                        </AtTabsPane>
                        <AtTabsPane current={subCurrent} index={1}>
                            <View style='padding: 1px 0px 100px;background-color: #FAFBFC;text-align: center;'>
                                { /*子标签类*/}
                                <AtSegmentedControl selectedColor='#FF9500'
                                    values={['全部', '好评', '中评', '差评', '公开', '匿名']}
                                    onClick={this.passSubCurrentToParent.bind(this)}
                                    current={subCurrent}
                                />
                                {
                                    this.state.subCurrent === 0
                                        ? <View className='tab-content'>
                                            <Text className='title'>全部</Text>
                                        </View>
                                        : null
                                }
                                {
                                    this.state.subCurrent === 1
                                        ? <View className='tab-content'>好评</View>
                                        : null
                                }
                                {
                                    this.state.subCurrent === 2
                                        ? <View className='tab-content'>中评</View>
                                        : null
                                }
                                {
                                    this.state.subCurrent === 3
                                        ? <View className='tab-content'>差评</View>
                                        : null
                                }
                                {
                                    this.state.subCurrent === 4
                                        ? <View className='tab-content'>公开</View>
                                        : null
                                }
                                {
                                    this.state.subCurrent === 5
                                        ? <View className='tab-content'>匿名</View>
                                        : null
                                }

                            </View>
                        </AtTabsPane>
                        <AtTabsPane current={this.state.current} index={2}>
                            <View style='padding: 100px 50px;background-color: #FAFBFC;text-align: center;'>标签页三的内容</View>
                        </AtTabsPane>
                    </AtTabs>

                </View>
            </View>
        )
    }
}

export default GoodCommentSection
